﻿Type=Class
Version=5.51
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
' Class module
' Name: DependenciesForm
' Purpose: Select dependencies used in the ItemForm field Dependencies
' Notes:
' TODO: None
'
Private Sub Class_Globals
	Private fx As JFX
	Private frm As Form
	'
	Public	Result As String
	' Buttons
	Private btnOK As Button
	Private btnCancel As Button
	Private lvwDependencies As ListView
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(itemdependencies As String)
	Main.AppLog("DependenciesForm Init :: Start")
	' Init the form and give the form a title and make it a utility form (toolbox type of form)
	frm.Initialize("frm", 300, 400)
	frm.Title = "Dependencies"
	frm.Resizable = False
	frm.SetFormStyle("UTILITY")
	frm.RootPane.LoadLayout("DependenciesForm")
	'
	'loadListViewStandard
	loadListViewCustomized(itemdependencies)
	'
	Main.AppLog("DependenciesForm Init :: End")
End Sub

' Show the ItemForm (toolbox Type)
Public Sub Show
	Main.AppLog("ItemForm Show :: Start")			
	frm.ShowAndWait						
	Main.AppLog("ItemForm Show :: End")			
End Sub

' Close the form with updated Dependencies field
Private Sub btnOK_Action
	Main.AppLog("ItemForm btnOK :: Start - Entries = " & lvwDependencies.Items.Size)			
	Dim s As String = ""
	' Get the checked items and build the return string
	For i = 0 To lvwDependencies.Items.Size - 1
		Dim cb As CheckBox
  		cb = lvwDependencies.Items.Get(i)
		' Log("> cb: " & i & " = " & cb.Text & " = " & cb.Checked)
		If cb.Checked = True Then s = s & cb.Text & ","
	Next
	' Log("> Result: " & s)
	' Remove the last ,
	If s.Length > 0 Then
		Dim n As Int = s.LastIndexOf(",")
		If n > -1 Then s = s.SubString2(0, n)
	End If
	Result = s
	frm.Close
	Main.AppLog("ItemForm btnOK :: End = " & Result)			
End Sub

' Close the form without any action
Private Sub btnCancel_Action
	Result = ""
	frm.Close
End Sub

' Build the listview standard layout from the ini entry dependencies
' NOT USED - as replaced by the customized version showing checkboxes
Private Sub loadListViewStandard
	lvwDependencies.MultipleSelection = True
	Dim strDependecies As String = Main.gmapIni.getKey("dependencies", "")
	If strDependecies.Length = 0 Then Return
	' Split the string
	Dim s() As String = Regex.Split(CRLF, strDependecies)
	lvwDependencies.Items.AddAll(s)
	'For i = 0 To s.Length - 1
  	'	Log(s(i))
	'Next
End Sub

' Build the listview checkbox layout from the ini entry dependencies
' Set the selected entries from the itemform field Depedencies to checked
Private Sub loadListViewCustomized(itemdependencies As String)
	' Get the defined dependencies - see configform.bas
	Dim strDependecies As String = Main.gmapIni.getKey("dependencies", "")
	' If no dependencies found, leave the sub.
	If strDependecies.Length = 0 Then Return
	' Split the dependencies string by CRLF (see rocodesnip.ini where string dependencies is split by \n
	Dim s() As String = Regex.Split(CRLF, strDependecies)
	' Build the listview items - each item is a checkbox
	For i = 0 To s.Length - 1
	    ' New checkbox
    	Dim cb As CheckBox
    	' Init with eventname - this is used to action checkbox event according to the checkbox property
    	cb.Initialize("listviewcb")
    	cb.Tag = i
    	cb.Text = s(i)
    	cb.Style = "-fx-text-fill: Blue; -fx-font-size: 1.1em; "
		' Check if this dependency is checked by the item
		If itemdependencies.Contains(cb.Text) Then cb.Checked = True
    	' Add the checkbox to the listview
    	lvwDependencies.Items.Add(cb)
  	Next
End Sub

