﻿Type=Class
Version=5.51
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
' Class module
' Name: InputForm
' Purpose: Dialog with a textinput field. The dialog is shown in the center of the mainform.
' Returns: Content of the textinputfield or an emptystring if cancelled
' Notes:
' TODO: None
'
Private Sub Class_Globals
	Private fx As JFX
	Private frm As Form
	'
	Private btnOK As Button
	Private btnCancel As Button
	Private txtInput As TextArea
	' The class Result
	Public	Result As String
	Private lblTitle As Label
End Sub

' Initializes the object.
' Parameter: The form Title and the List of MenuItems
Public Sub Initialize(title As String, inputstring As String)
	Main.AppLog("InputForm Init :: Start")
	' Init the form and give the form a title and make it a utility form (toolbox type of form)
	frm.Initialize("frm", 170, 200)
	frm.WindowTop = Main.MainForm.WindowTop + (Main.MainForm.WindowHeight / 2) - (200 / 2)
	frm.WindowLeft = Main.MainForm.WindowLeft + (Main.MainForm.WindowWidth / 2) - (170 / 2)
	frm.title = title
	frm.Resizable = False
	frm.SetFormStyle("UNDECORATED")		' No borders
	frm.RootPane.LoadLayout("InputForm")
	lblTitle.Text = title
	txtInput.Text = inputstring
	Main.AppLog("InputForm Init :: End")
End Sub

' Show the ItemForm (toolbox Type)
Public Sub Show
	Main.AppLog("ItemForm Show :: Start")			
	frm.ShowAndWait						
	Main.AppLog("ItemForm Show :: End")			
End Sub

' Close the form with updated MenuResult and MenuResultIndex
Private Sub btnOK_Action
	Main.AppLog("ItemForm btnOK :: Start")			
	Result = txtInput.Text
	frm.Close
	Main.AppLog("ItemForm btnOK :: End = " & Result)			
End Sub

' Close the form without any action
Private Sub btnCancel_Action
	Result = ""
	frm.Close
End Sub
