﻿Type=Class
Version=5.51
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
' Class module
' Name: ItemForm
' Purpose: Manage Items = New, Edit
' Notes:
' TODO: None
'
Private Sub Class_Globals
	Private fx As JFX
	Private frm As Form
	' Set the itemformmode: 0 = View, 1 = New, 2 = New Item from Clipboard, 3 = Edit
	Private ItemFormMode As Int
	' Set result from OK = True or CANCEL = False
	Public Result As Boolean

	' Toobar Bottom
	Private btnOK As Button
	Private btnCancel As Button

	' Form Fields
	Private txtFieldCode As TextArea
	Private txtFieldSubname As TextField
	Private txtFieldDescription As TextField
	Private txtFieldDependencies As TextField
	Private txtFieldTags As TextField
	Private txtFieldModified As TextField
	Private lblFieldID As Label
	' Form Buttons
	Private btnModified As Button
	Private btnDependencies As Button
	' Extra Functions
	Private cbExtraFunctions As ComboBox
	Private CEXTRAFUNCTIONS() As String= Array As String("Insert Date&Time", "Insert Line", "Code to Uppercase")

	Private btnCopyItemClipboard As Button
	Private btnSetFavorite As Button
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Title As String, Mode As Int, ID As String, SubName As String)
	Main.AppLog("ItemForm Init :: Start" & " - Mode: " & Mode & ",ID: " & ID & ", SubName: " & SubName)
	' Init the form (w/H defined in ini file) and give the form a title and make it a utility form (toolbox type of form)
	frm.Initialize("frm", Main.gmapIni.getKey("itemwindowwidth", 600), Main.gmapIni.getKey("itemwindowheight", 600))
	frm.RootPane.LoadLayout("ItemForm")
	frm.Resizable = False
	frm.SetFormStyle("UTILITY")
	' Set title depending on mode
	If SubName.Length > 0 Then Title = Title & " - " & SubName
	frm.Title = Title
	' Set the tooltips
	txtFieldCode.TooltipText = "Define the code."
	txtFieldSubname.TooltipText = "Define the name of the codesnippet"
	txtFieldDescription.TooltipText = "Describe the codesnippet"
	txtFieldDependencies.TooltipText = "Define the library dependencies. Select from the list."
	txtFieldTags.TooltipText = "Define the tags separated by a ,. Like CSS, FXML"
	txtFieldModified.TooltipText = "Enter the date modified"
	lblFieldID.TooltipText = "ID number of this codesnippet"
	'
	cbExtraFunctions.Items.AddAll(CEXTRAFUNCTIONS)
	'
	Main.AppLog("> Set Mode")
	' Get the mode and populate the fields accordingly
	ItemFormMode = Mode
	' NEW ITEM = All fields have prompt text (defined using the Java FX Scene Builder
	If Mode = 1 Then
		Main.AppLog("> Mode 1 settings")
		' Set date & time to now in field modified
		btnModified_Action			
	End If
	If Mode = 2 Then
		Main.AppLog("> Mode 2 settings")
		NewItemFromClipboard_Action
	End If
	' EDIT ITEM = select the item data and set the fields
	' TODO: change where clause to ID instead of subname
	If Mode = 3 Then
		Main.AppLog("> Mode 3 settings")
		Dim strSQL As String = "SELECT " & Main.CTABLECODESNIPFIELDSS & " FROM " & Main.CTABLECODESNIP & " WHERE SubName = '" & SubName & "'"
		Main.AppLog("> SQL: " & strSQL)
		Dim mapItem As Map = DBUtils.ExecuteMap(Main.gSQL, strSQL, Null)
		Main.AppLog ("> Items: " & mapItem.Size & " - " & mapItem.GetValueAt(1))
		putMapToCodeSnipFields(mapItem)
	End If
	'
	Main.AppLog("ItemForm Init :: End")
End Sub

' Show the ItemForm (toolbox Type)
Public Sub Show
	Main.AppLog("ItemForm Show :: Start")			
	txtFieldCode.WrapText = (Main.gmapIni.getKey("codewraptext", False) = True)
	frm.ShowAndWait						
	Main.AppLog("ItemForm Show :: End")			
End Sub

' Disable Close the form via system button. Close either via OK or CANCEL button
'Private Sub frm_CloseRequest (EventData As Event)
	' EventData.Consume
'End Sub

' Close the dialog as OK.
' Returns Result = True and the content of the textfieldInput
Private Sub btnOK_Action
	' Insert new Item
	If (ItemFormMode = 1) OR (ItemFormMode = 2) Then
		btnModified_Action
		NewItem_Action
	End If
	' Update Item
	If ItemFormMode = 3 Then
		btnModified_Action
		UpdateItem_Action	
	End If
	Result = True
	frm.Close
End Sub

' Close the dialog as Cancel.
' Returns Result = False and an empty textInput
Private Sub btnCancel_Action
	Result = False
	frm.Close
End Sub

'
' ITEM DETAILS
'

Private Sub btnModified_Action
	DateTime.DateFormat	= Main.gmapIni.getKey("datetimeformat", "dd.MM.yyyy HH:mm")
	txtFieldModified.Text = DateTime.Date(DateTime.now)
End Sub

' Pressing enter in the subnamefield, will set the focus on the description field
Private Sub txtFieldSubname_Action
	txtFieldDescription.RequestFocus	
End Sub

Private Sub txtFieldDescription_Action
	txtFieldDependencies.RequestFocus	
End Sub

Private Sub txtFieldDependencies_Action
	txtFieldTags.RequestFocus
End Sub

Private Sub btnDependencies_Action
	Dim sd As DependenciesForm
	sd.Initialize(txtFieldDependencies.Text)
	sd.Show
	If sd.Result.Length > 0 Then txtFieldDependencies.Text = sd.Result
End Sub

Private Sub txtFieldTags_Action
	txtFieldModified.RequestFocus
End Sub

Private Sub txtFieldModified_Action
	txtFieldCode.RequestFocus
End Sub

'
' DATABASE
'

' "ID,SubName,Description,Code,Dependencies,Tags,Modified"
Private Sub putCodeSnipFieldsToMap As Map
	Dim m As Map
	m.Initialize
	' First field = ID; Is set as autoinc, means do not change as sqlite will handle
	'm.Put(CTABLECODESNIPFIELDS(0), i)
	m.Put(Main.CTABLECODESNIPFIELDS(Main.CSUBNAME), txtFieldSubname.text)
	m.Put(Main.CTABLECODESNIPFIELDS(Main.CDESCRIPTION), txtFieldDescription.text)
	'txtFieldCode.Text = txtFieldCode.Text.Replace("'", "\'")
	m.Put(Main.CTABLECODESNIPFIELDS(Main.CCODE), txtFieldCode.text)
	m.Put(Main.CTABLECODESNIPFIELDS(Main.CDEPENDENCIES), txtFieldDependencies.text)
	m.Put(Main.CTABLECODESNIPFIELDS(Main.CTAGS), txtFieldTags.text)
	m.Put(Main.CTABLECODESNIPFIELDS(Main.CMODIFIED), txtFieldModified.text)
	' Return the map
	Main.AppLog(m.Size & ": SubName = " & txtFieldSubname.text)
	Return m
End Sub

' "ID,SubName,Description,Code,Dependencies,Tags,Modified"
Private Sub putMapToCodeSnipFields(m As Map)
	If m.IsInitialized = False Then Return
	lblFieldID.Text = m.GetValueAt(Main.CID)
	txtFieldSubname.text = m.GetValueAt(Main.CSUBNAME)
	txtFieldDescription.text = m.GetValueAt(Main.CDESCRIPTION)
	txtFieldCode.text = m.GetValueAt(Main.CCODE)
	'txtFieldCode.Text = txtFieldCode.Text.Replace("\'", "'")
	txtFieldDependencies.text = m.GetValueAt(Main.CDEPENDENCIES)
	txtFieldTags.text = m.GetValueAt(Main.CTAGS)
	txtFieldModified.text = m.GetValueAt(Main.CMODIFIED)
End Sub

' CodeSnippet Entry
' SubName:
' Description: A brief outline of the purpose of the snippet
' Code (In code block)
' Dependencies: A List of additional libraries that the code needs To work.
' Tags: <List of keywords>

' Check if the fields SubName and Code are entered correctly
' Returns: True if OK, else False
Private Sub checkFields(strHdg As String) As Boolean
	If txtFieldSubname.text = "" Then
		Main.gDlg.ErrorDialog(strHdg, "Check Fields", "Error: No SubName entered. Pls enter a SubName.")
		Return False
	End If
	If txtFieldCode.text = "" Then
		Main.gDlg.ErrorDialog(strHdg, "Check Fields", "Error: No Code entered. Pls enter a Code.")
		Return False
	End If
	Return True
End Sub

'
' ACTIONS
' Assigned to buttons, menu items
'

' Insert the new data using the list of maps - clear first, insert and reload listview
Private Sub NewItem_Action
	Main.AppLog("NewItem_Action :: Start")
	Dim strHdg As String = "Insert Item"
	If checkFields(strHdg) = False Then Return
	Main.AppLog("> Fields OK")
	Main.AppLog("> Subname: " & txtFieldSubname.text)
	Main.gListOfMaps.Clear
	Main.gListOfMaps.Add(putCodeSnipFieldsToMap)
	Main.AppLog("> Insert Maps")
	DBUtils.InsertMaps(Main.gSQL, Main.CTABLECODESNIP, Main.gListOfMaps)
	Main.AppLog("> LoadListView")
	Main.loadListView(Main.lvwItemList.items.Size)
	Main.AppLog("NewItem_Action :: End")
End Sub

' Add a new item from the clipboard
' First line is the field SubName, remaining set in the field Code
Private Sub NewItemFromClipboard_Action
	Main.AppLog("NewItemFromClipboard_Action :: Start")
	Dim cs As String = fx.Clipboard.GetString
	If cs.Length = 0 Then Return
	' Split the text in to array of strings. The first string s(0) is assigned as the SubName
	Dim s() As String = Regex.Split(CRLF, cs)
	If s.Length = 0 Then Return
	txtFieldSubname.Text = s(0)
	If s.Length > 1 Then
		For i = 1 To s.Length - 1
			txtFieldCode.Text = txtFieldCode.Text & s(i) & CRLF
		Next
	End If
	' Update date & time to now using date format as specified in the configform
	btnModified_Action			
	Main.AppLog("NewItemFromClipboard_Action :: End")
End Sub

' Update selected item using ID field
Private Sub UpdateItem_Action
	Main.AppLog("UpdateItem_Action :: Start")
	Dim strHdg As String = "Update Entry"
	If checkFields(strHdg) = False Then Return
	Main.AppLog("> ID: " & lblFieldID.text)
	'Set the wherefields = Only the ID is used
	Dim WhereFields As Map
	WhereFields.Initialize
	WhereFields.Put(Main.CTABLECODESNIPFIELDS(0), lblFieldID.text)
	' Update the new data using a map
	DBUtils.UpdateRecord2(Main.gSQL, Main.CTABLECODESNIP, putCodeSnipFieldsToMap, WhereFields)
	' Reload the tableview with the updated data
	Main.loadListView(Main.lvwItemList.SelectedIndex)
	Main.AppLog("UpdateItem_Action :: End")
End Sub

'
' EXTRA FUNCTIONS FOR THE CODE
'

' Insert text at caret position in code textfield
' Parameter TextArea
' Parameter String to insert
Private Sub TextAreaInsertText(ta As TextArea, s As String)
  Dim jo As JavaObject = ta
  Dim npos As Int = jo.RunMethod("getCaretPosition", Null)
  If npos < 0 Then Return
  jo.RunMethod("insertText", Array As Object(npos, s))
End Sub

' Combobox with extra functions. The functions are defined as global array
' CEXTRAFUNCTIONS = "Insert Date&Time", "Insert Line", "Code to Uppercase"
Sub cbExtraFunctions_SelectedIndexChanged(Index As Int, Value As Object)
	Select Index
		Case 0
			TextAreaInsertText(txtFieldCode, DateTime.Date(DateTime.Now))
		Case 1
			TextAreaInsertText(txtFieldCode, "-----")
		Case 2
			txtFieldCode.Text = txtFieldCode.Text.ToUpperCase
	End Select
End Sub

' Copy the selected item to the clipboard
Sub btnCopyItemClipboard_Action
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("Name:").Append(txtFieldSubname.text).append(CRLF)
	sb.Append("Description:").Append(txtFieldDescription.text).Append(CRLF)
	sb.Append("Dependencies:").Append(txtFieldDependencies.text).Append(CRLF)
	sb.Append("Tags:").Append(txtFieldTags.text).Append(CRLF)
	sb.Append("Modified:").Append(txtFieldModified.text).Append(CRLF)
	sb.Append("Code:").Append(CRLF).Append(txtFieldCode.text).Append(CRLF)
	fx.Clipboard.SetString(sb.ToString)
End Sub

' Set this item as your favorite entry
Sub btnSetFavorite_Action
	Main.gmapIni.putKey("favoriteitem", txtFieldSubname.text)
End Sub
