﻿Type=Class
Version=5.51
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
' Class module
' Name: PopupMenuForm
' Purpose: Dialog with menu options in a listview.  The dialog is shown in the center of the mainform.
' Returns: Selected listitem as string and index
' Notes:
' TODO: None
'
Private Sub Class_Globals
	Private fx As JFX
	Private frm As Form
	'
	Private btnOK As Button
	Private btnCancel As Button
	Private lvwMenuItems As ListView
	' The class Result
	Public	MenuResult As String
	Public	MenuResultIndex As Int
End Sub

' Initializes the object.
' Parameter: The form Title and the List of MenuItems
Public Sub Initialize(title As String, lstMenuItems As List)
	Main.AppLog("PopupMenuForm Init :: Start")
	' Init the form and give the form a title and make it a utility form (toolbox type of form)
	frm.Initialize("frm", 170, 200)
	frm.WindowTop = Main.MainForm.WindowTop + (Main.MainForm.WindowHeight / 2) - (200 / 2)
	frm.WindowLeft = Main.MainForm.WindowLeft + (Main.MainForm.WindowWidth / 2) - (170 / 2)
	frm.title = title
	frm.Resizable = False
	frm.SetFormStyle("UNDECORATED")		' No borders
	frm.RootPane.LoadLayout("PopupMenuForm")
	lvwMenuItems.Items.AddAll(lstMenuItems)
	Main.AppLog("PopupMenuForm Init :: End")
End Sub

' Show the ItemForm (toolbox Type)
Public Sub Show
	Main.AppLog("ItemForm Show :: Start")			
	If lvwMenuItems.Items.Size > 0 Then lvwMenuItems.SelectedIndex = 0
	lvwMenuItems.RequestFocus
	frm.ShowAndWait						
	Main.AppLog("ItemForm Show :: End")			
End Sub

' Close the form with updated MenuResult and MenuResultIndex
Private Sub btnOK_Action
	Main.AppLog("ItemForm btnOK :: Start")			
	MenuResult = lvwMenuItems.SelectedItem
	MenuResultIndex = lvwMenuItems.SelectedIndex
	frm.Close
	Main.AppLog("ItemForm btnOK :: End = " & MenuResult)			
End Sub

' Close the form without any action
Private Sub btnCancel_Action
	MenuResult = ""
	MenuResultIndex = -1
	frm.Close
End Sub
